use crate::authorization::roles::Role;
use crate::Roles;
use api::permissions_capnp::permissions::{
    self, ListRolesParams, ListRolesResults,
};
use capnp::capability::Promise;
use capnp::Error;
use tracing::Span;

use crate::session::SessionHandle;

const TARGET: &str = "bffh::api::permissionsystem";

pub struct Permissions {
    span: Span,
    roles: Roles,
}

impl Permissions {
    pub fn new(session: SessionHandle) -> Self {
        let span = tracing::info_span!(target: TARGET, "PermissionSystem",);
        Self {
            span,
            roles: session.roles,
        }
    }
}

impl permissions::Server for Permissions {

}
