/*
 * Copyright © 2022 RLKM UG (haftungsbeschränkt).
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <https://www.gnu.org/licenses/>.
 */


use std::marker::PhantomData;
use lmdb::Transaction;
use crate::db;
use crate::db::{Adapter, DB};

pub struct Index<I, A> {
    db: DB<A>,
    _marker: PhantomData<I>,
}

impl<I: AsRef<[u8]>, A: Adapter> Index<I, A> {
    pub fn get<T: Transaction>(
        &self, txn: &T, lookup: I,
    ) -> Result<Option<A::Item>, db::Error> {
        self.db.get(txn, &lookup)
    }
}